# coding: utf-8

"""
    Humanloop API

    The Humanloop API allows you to interact with Humanloop from your product or service.  You can do this through HTTP requests from any language or via our official Python or TypeScript SDK.  To install the official [Python SDK](https://pypi.org/project/humanloop/), run the following command:  ```bash pip install humanloop ```  To install the official [TypeScript SDK](https://www.npmjs.com/package/humanloop), run the following command:  ```bash npm i humanloop ```  ---  Guides and further details about key concepts can be found in [our docs](https://docs.humanloop.com/).

    The version of the OpenAPI document: 4.0.1
    Generated by: https://konfigthis.com
"""

from datetime import datetime, date
import typing
from enum import Enum
from typing_extensions import TypedDict, Literal

from humanloop.type.feedback_class import FeedbackClass
from humanloop.type.feedback_label_request import FeedbackLabelRequest
from humanloop.type.feedback_type_request import FeedbackTypeRequest
from humanloop.type.label_sentiment import LabelSentiment

class RequiredCreateProjectRequest(TypedDict):
    # Unique project name.
    name: str

class OptionalCreateProjectRequest(TypedDict, total=False):
    # Feedback types to be created.
    feedback_types: typing.List[FeedbackTypeRequest]

    # ID of directory to assign project to. Starts with `dir_`. If not provided, the project will be created in the root directory.
    directory_id: str

class CreateProjectRequest(RequiredCreateProjectRequest, OptionalCreateProjectRequest):
    pass
